*
*	FM-7 EMULATOR "XM7"
*
*	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
*	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
*	                        MICRO 8 Support by Toshio Fukui
*
*	[ ROMZ[o(XM7 V1.1Ή) ]
*
*	Ώۋ@EfBA^CvɉăAZuɃIvVw肷邱
*		-dDISKTYPE=0	360KB(2D)  ʏtH[}bg
*		-dDISKTYPE=1	720KB(2DD) 1gbNtH[}bg(gps)
*		-dDISKTYPE=2	720KB(2DD) ʏtH[}bg(gps)
*		-dFBLOADM		DISK BASICp
*

	if	defined(FBLOADM)
				ORG		$0FE0
	else
				ORG		$1000
	endif

*
*	萔` (CVXe)
*
STACK			EQU		$0F00			* X^bNŏI
BUFFER			EQU		$0F80			* ėpobt@
KANJI_BUF		EQU		$0FE8			* obt@
DISK_BUF		EQU		$2800			* fBXNobt@
SHARED			EQU		$FC80			* LRAM

*
*	萔` (CI/O)
*
KEYDAT			EQU		$FD01			* L[f[^WX^
SUBMODE			EQU		$FD04			* TuVXe[hWX^
SUBSIN			EQU		$FD05			* TuVXeC^tF[XWX^
RS232D			EQU		$FD06			* USART f[^WX^
RS232S			EQU		$FD07			* USART Xe[^XWX^
RS232C			EQU		RS232S			* USART R}hWX^
RSBAUD			EQU		$FD0B			* RS-232C {[[gWX^
RSENABLE		EQU		$FD0C			* RS-232C Cl[uWX^
BANKSEL			EQU		$FD0F			* ROM/RAMZNgWX^
INITDIS			EQU		$FD10			* CjVG[^ROM fBZ[uWX^
SUBSTAT			EQU		$FD12			* Tu[hXe[^XWX^
SUBBANK			EQU		$FD13			* TuoNWX^
FDCSTAT			EQU		$FD18			* FDC Xe[^XWX^
FDCCMD			EQU		FDCSTAT			* FDC R}hWX^
FDCTRACK		EQU		$FD19			* FDC gbNWX^
FDCSECTOR		EQU		$FD1A			* FDC ZN^WX^
FDCDATA			EQU		$FD1B			* FDC f[^WX^
FDDSIDE			EQU		$FD1C			* FDD TChWX^
FDDDRIVE		EQU		$FD1D			* FDD hCuWX^
FDDMODE			EQU		$FD1E			* FDD [hWX^
FDDDRQ			EQU		$FD1F			* FDC DRQ/IRQWX^
KNJ1ADR			EQU		$FD20			* ꐅ AhXWX^
KNJ1DATA		EQU		$FD22			* ꐅ f[^WX^
KNJ2ADR			EQU		$FD2C			* 񐅏 AhXWX^
KNJ2DATA		EQU		$FD2E			* 񐅏 f[^WX^
DICBANK			EQU		$FD2E			* ROM oNWX^
MMR				EQU		$FD80			* MMR }bsOWX^
MSGR			EQU		$FD90			* MMR ZOgWX^
MMSR			EQU		$FD93			* MMR [hZNgWX^
MSSW1			EQU		$FD94			* [hZNgXCb`1 (40/20)
MSSW2			EQU		$FD95			* [hZNgXCb`2 (EX)

*
*	萔` (TuI/O)
*
SUBMODEL4		EQU		$D405			* Tu[hWX^ (L4)
CRTDSP			EQU		$D408			* CRT ON/OFFWX^
VACC			EQU		$D409			* VRAMANZXtO
ALUCMD			EQU		$D410			* _ZR}hWX^
ALUCOL			EQU		$D411			* _ZJ[WX^
ALUMASK			EQU		$D412			* _Z}XNWX^
ALUDIS			EQU		$D41B			* _ZoNfBZ[uWX^
KENCDAT			EQU		$D431			* L[GR[_f[^WX^
KENCSTA			EQU		$D432			* L[GR[_Xe[^XWX^

*
*	[NGA`
*
RS_FLAG			EQU		$00			* VAo̓tO
DRIVE			EQU		$01			* ANZXhCu
TRACK			EQU		$02			* ANZXgbN
DRIVE0_T		EQU		$03			* hCu0̃gbN
DRIVE1_T		EQU		$04			* hCu1̃gbN
SIDE			EQU		$05			* ANZXTCh
SECTOR			EQU		$06			* ANZXZN^
SECTORS			EQU		$07			* AZN^
CLUSTER			EQU		$08			* t@C擪NX^
CLUSTERS		EQU		$0A			* g[^NX^(1NX^1KB)
LASTBYTE		EQU		$0C			* ŏINX^̃oCg
COLOR			EQU		$0E			* J[R[h
TYPE			EQU		$0F			* FDCR}h^Cv
C_TRACK			EQU		$10			* JggbN
C_SIDE			EQU		$11			* JgTCh
C_SECTOR		EQU		$12			* JgZN^
C_SECTORS		EQU		$13			* JgZN^
FM77_FLAG		EQU		RS_FLAG		* FM-77tO
L4_FLAG			EQU		COLOR		* 400CtO (L4)

*
*	AZu`
*
M_FM7			EQU		0			* FM-7V[YS@
M_FM77AV		EQU		1			* FM77AVV[YS@
M_FM77AV40		EQU		2			* FM77AV40/EX/SX
M_FM77AVDIC		EQU		3			* FM77AV ROM
M_KANJI			EQU		4			* FM77AV40EX/SX(ROM)
M_FM8			EQU		8			* FM-8
D_NORM2D		EQU		0			* 2D (360KB) ʏtH[}bg
D_SKIP2DD		EQU		1			* 2DD(720KB) PgbNtH[}bg
D_NORM2DD		EQU		2			* 2DD(720KB) ʏtH[}bg

*
*	@CMT I/FoRp ]vO
*
	if	defined(FBLOADM)
ENTRY			ORCC	#$50
				LEAX	<START,PCR
				LDU		#$1000
				LDY		#((PRGEND-START)|1)+1
TFRLOOP			LDD		,X++
				STD		,U++
				LEAY	-2,Y
				BNE		TFRLOOP
				JMP		$1000

				ORG		$1000
	endif

*
*	vOX^[g
*
START			BRA		MAIN

*
*	vOwb_
*
HEADER			FCC		/TINY-DOS(mini) for FM-7  /
				FCC		/Copyright 1991-1992,1999 by ohD/
				FCB		$0D,$0A,$00

HEADER2			EQU		*
				FCC		/SAVEROM8/
				FCC		/ V1.38  /
				FCC		"Copyright 1999 ohD/ 2003-2019 Ryu Takegami"
				FCB		$0D,$0A,$00

*
*	CvO
*
				ORG		START+$80
MAIN			ORCC	#$50
	if	defined(FBLOADM)
				LDS		#STACK
	else
				LEAS	STACK,PCR
	endif

* n[hEFA
	if	defined(RSDRIVER)
				LBSR	RS_INIT
	endif
				LBSR	INIT
				LBSR	FM7_INIT

* N^Cg\
	if	(DISKTYPE==D_NORM2D)||(defined(FBLOADM))
				LEAX	TITLE_MSG,PCR
				LBSR	PUT_STRING
				LEAX	TITLE_MSG2,PCR
				LBSR	PUT_STRING
				LEAX	SPACE_MSG,PCR
				LBSR	PUT_STRING
				LBSR	KEY_SPACE
	endif

* fBXNtH[}bg
				LBSR	DISK_RST
				LBSR	MS_FORMAT

* CZ[u
MAINSAVE		EQU		*
				LBSR	FBASIC
				LBSR	BOOT_BAS
				LBSR	BOOT_DOS
				LBSR	BOOT_BBL
				LBSR	BOOT_DBGSFD
				LBSR	KANJI

* TuZ[u
SUBSAVE			EQU		*
				LBSR	SUBSYS_C

* (bZ[W\E[v)
				LBSR	CLS
				LEAX	COMPLETE_MSG,PCR
				LBSR	PUT_STRING
				BRA		*


*
* 
*
INIT			LEAX	START,PCR
				LEAX	-$100,X
				TFR		X,D
				TFR		A,DP
* [NNA
				CLRA
INIT1			CLR	,X+
				DECA
				BNE	INIT1
* ʏ
				LEAX	SUBINIT_CMD,PCR
				LDB		#$09
				LBSR	SUB_CMD
				LEAX	SUBCONS_CMD,PCR
				LDB		#$02
				LBSR	SUB_CMD
INIT2			RTS

*--[ ROMZ[o(S@틤ʕ) ]------------------------------------------------

*
*	F-BASIC ROM
*
FBASIC			LBSR	CLS
				LDX		$FE03
				CMPX	#$FE67		* FM-8 BASIC
				BEQ		FBASIC2
				LEAX	BOOTB_DIPSW_MSG,PCR
				LBSR	PRINT
FBASIC1			LDX		$FE03
				CMPX	#$FE67		* FM-8 BASIC
				BNE		FBASIC1
FBASIC2			LBSR	CLS
				LEAX	FBASIC_MSG,PCR
				LBSR	PUT_STRING
				LEAX	FBASIC_FN,PCR
				LDD		#31
				STD		<CLUSTERS
				LDD		#1024
				STD		<LASTBYTE
				LBSR	FILE_CREATE
				LDX		#$8000
				LDU		#31
				LBSR	FILE_WRITE
				RTS

*
*	KANJI ROM (ꐅ)
*
KANJI			CLRA
				CLRB
				STD		KNJ1ADR
				LDD		KNJ1DATA
				CMPD	#$FFFF
				BEQ		KANJI5

				LBSR	CLS
				LEAX	KANJI_MSG,PCR
				LBSR	PUT_STRING
				LEAX	KANJI_FN,PCR
				LDD		#$80
				STD		<CLUSTERS
				LDD		#1024
				STD		<LASTBYTE
				LBSR	FILE_CREATE
* 8񃋁[v
				LDX		#$0000
KANJI1			LDU		#$4000
KANJI2			STX		KNJ1ADR
				LDD		KNJ1DATA
				STD		,U++
				LEAX	1,X
				CMPU	#$8000
				BNE		KANJI2
* Z[u
				PSHS	X
				LDX		#$4000
				LDU		#16
				LBSR	FILE_WRITE
				PULS	X
* NEXT
				CMPX	#$0000
				BNE		KANJI1
KANJI5			RTS

*--[ ROMZ[o(FM-8) ]--------------------------------------------------------

*
*	BOOT(BASIC) ROM
*
BOOT_BAS		LBSR	CLS
				LDX		$FE03
				CMPX	#$FE67		* FM-8 BASIC
				BEQ		BOOT_BAS2
				LEAX	BOOTB_DIPSW_MSG,PCR
				LBSR	PRINT
BOOT_BAS1		LDX		$FE03
				CMPX	#$FE67		* FM-8 BASIC
				BNE		BOOT_BAS1
				LBSR	CLS
BOOT_BAS2		LEAX	BOOTBAS_MSG,PCR
				LBSR	PRINT
				LEAX	BOOTBAS_FN,PCR
				LDD		#1
				STD		<CLUSTERS
				LDD		#512
				STD		<LASTBYTE
				LBSR	FILE_CREATE
				LDU		#1
				LBSR	FILE_WRITE
				RTS

*
*	BOOT(DOS) ROM
*
BOOT_DOS		LBSR	CLS
				LDX		$FE03
				CMPX	#$FE6B		* FM-8 DOS
				BEQ		BOOT_DOS2
				LEAX	BOOTD_DIPSW_MSG,PCR
				LBSR	PRINT
BOOT_DOS1		LDX		$FE03
				CMPX	#$FE6B		* FM-8 DOS
				BNE		BOOT_DOS1
BOOT_DOS2		LBSR	CLS
				LEAX	BOOTDOS_MSG,PCR
				LBSR	PRINT
				LEAX	BOOTDOS_FN,PCR
				LDD		#1
				STD		<CLUSTERS
				LDD		#512
				STD		<LASTBYTE
				LBSR	FILE_CREATE
				LDU		#1
				LBSR	FILE_WRITE
				RTS

*
*	BOOT(BBL) ROM
*
BOOT_BBL		LBSR	CLS
				LDX		$FE03
				CMPX	#$FE5B		* FM-8 BBL
				BEQ		BOOT_BBL2
				LEAX	BOOTL_DIPSW_MSG,PCR
				LBSR	PRINT
BOOT_BBL1		LDX		$FE03
				CMPX	#$FE5B		* FM-8 BBL
				BNE		BOOT_BBL1
BOOT_BBL2		LBSR	CLS
				LEAX	BOOTBBL_MSG,PCR
				LBSR	PRINT
				LEAX	BOOTBBL_FN,PCR
				LDD		#1
				STD		<CLUSTERS
				LDD		#512
				STD		<LASTBYTE
				LBSR	FILE_CREATE
				LDX		#$FE00
				LDU		#1
				LBSR	FILE_WRITE
				RTS

*
*	BOOT(DBG/SFD) ROM
*
BOOT_DBGSFD		LBSR	CLS
				LDX		$FE03
				CMPX	#$FE84		* FM-8 DBG
				BEQ		BOOT_DBGSFD2
				CMPX	#$FE82		* FM-8 SFD
				BEQ		BOOT_DBGSFD3
				LEAX	BOOTG_DIPSW_MSG,PCR
				LBSR	PRINT
BOOT_DBGSFD1	LDX		$FE03
				CMPX	#$FE84		* FM-8 DBG
				BEQ		BOOT_DBGSFD2
				CMPX	#$FE82		* FM-8 SFD
				BEQ		BOOT_DBGSFD3
				BRA		BOOT_DBGSFD1
BOOT_DBGSFD2	LBSR	CLS
				LEAX	BOOTDBG_MSG,PCR
				LBSR	PRINT
				LEAX	BOOTDBG_FN,PCR
				BRA		BOOT_DBGSFD4
BOOT_DBGSFD3	LBSR	CLS
				LEAX	BOOTSFD_MSG,PCR
				LBSR	PRINT
				LEAX	BOOTSFD_FN,PCR
BOOT_DBGSFD4	LDD		#1
				STD		<CLUSTERS
				LDD		#512
				STD		<LASTBYTE
				LBSR	FILE_CREATE
				CLR		INITDIS
				LDX		#$FE00
				LDU		#1
				LBSR	FILE_WRITE
				RTS

*
*	SUBSYSTEM (TYPE-C) ROM
*
SUBSYS_C		LBSR	CLS
				LEAX	SUBSYSC_MSG,PCR
				LBSR	PRINT
				LEAX	SUBSYSC_FN,PCR
				LDD		#10
				STD		<CLUSTERS
				LDD		#1024
				STD		<LASTBYTE
				LBSR	FILE_CREATE
* Tuj^]
				LDX		#$D800
				LDY		#$4800
SUBSYS_C1		PSHS	X,Y
				STX		SRCADR,PCR
				LEAX	TFR_CMD,PCR
				LDB		#TFR_CMDe-TFR_CMD
				LBSR	SUB_CMD
				PULS	X,Y
				LBSR	SUB_HALT
				LDU		#$FCC0
				LDB		#$40
SUBSYS_C2		LDA		,U+
				STA		,Y+
				DECB
				BNE		SUBSYS_C2
				LDA		#$80
				STA		SHARED
				CLR		SUBSIN
				LEAX	$40,X
				BNE		SUBSYS_C1
* Z[u
				LDX		#$4800
				LDU		#10
				LBSR	FILE_WRITE
				RTS

*
* Tuj^]peiXR}h
*
TFR_CMD			FCB		$3F,$59,$41,$4D,$41,$55,$43,$48,$49
				FCB		$91
SRCADR			FDB		$0000,$D3C0,$0040
				FCB		$90
TFR_CMDe		EQU		*

*--[ FM-7 ]-------------------------------------------------------------------

*
*	FM-7
*
FM7_INIT		EQU		*
				CLR		<FM77_FLAG
				RTS

*
*	Xy[X҂
*
KEY_SPACE		EQU		*
KEY_SPACE1		LEAX	INKEY_CMD,PCR
				LDB		#2
				LBSR	SUB_CMD
				LBSR	SUB_HALT
				LDB		#$80
				STB		SHARED
				LDD		SHARED+3
				CLR		SUBSIN
				TSTB
				BEQ		KEY_SPACE1
				CMPA	#$20
				BNE		KEY_SPACE1
				RTS

*
*	Xy[X̓`FbN
*
KEY_CHKSP		LEAX	INKEY_CHK_CMD,PCR
				LDB		#2
				LBSR	SUB_CMD
				LBSR	SUB_HALT
				LDB		#$80
				STB		SHARED
				LDD		SHARED+3
				CLR		SUBSIN
				TSTB
				BEQ		KEY_CHKSP1
				CMPA	#$20
				BNE		KEY_CHKSP1
				FCB		$86
KEY_CHKSP1		CLRA
				RTS

*
*	ʃNA
*
CLS				EQU		*
				LEAX	CLS_CMD,PCR
				LDB		#CLS_CMDe-CLS_CMD
				LBRA	SUB_CMD

*
*	TuCPU ʃNAvO
*
CLS_CMD			FCB		$3F,$59,$41,$4D,$41,$55,$43,$48,$49
				FCB		$93,$D3,$8F,$90
*
CLSENT			LDU		#$0000+80*200
				BSR		CLS1
				LDU		#$4000+80*200
				BSR		CLS1
				LDU		#$8000+80*200
CLS1			TST		VACC
				LDB		#100
				PSHS	B
				LDX		#0
				TFR		X,D
				TFR		X,Y
CLS2			PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D,X,Y
				PSHU	D
				DEC		,S
				BNE		CLS2
				CLR		VACC
				PULS	B,PC
CLS_CMDe		EQU		*

*--[ TuCPU ]----------------------------------------------------------------

*
*	TuCPU HALT
*
*	USEREG: A
*
SUB_HALT		LDA		SUBSIN
				BMI		SUB_HALT
				LDA		#$80
				STA		SUBSIN
SUB_HALT1		LDA		SUBSIN
				BPL		SUB_HALT1
				RTS

*
*	TuCPU R}ho
*
*	PARAM.: X	R}hf[^($FC82`)
*			B	M
*	USEREG: A,B,X,U
*
SUB_CMD			LBSR	SUB_HALT
* f[^
				LDU		#SHARED
				CLR		,U+
				CLR		,U+
SUB_CMD1		LDA		,X+
				STA		,U+
				DECB
				BNE		SUB_CMD1
* TuCPU s
				CLR		SUBSIN
				RTS

*
*	o (FM-7p,ANKp)
*
*	PARAM.: X	
*	USEREG: A,B,X,U
*
PUT_STRING		EQU		*
PRINT			TFR		X,U
* 𐔂
				CLRB
PRINT0			LEAU	BUFFER,PCR
				LDA		#$03
				CLRB
				STA		,U+
				STB		,U+
PRINT1			LDA		,X+
				TSTA
				BEQ		PRINT2
				STA		,U+
				INCB
				BRA		PRINT1
PRINT2			PSHS	A,X
				LEAX	BUFFER,PCR
				STB		1,X
				INCB
				INCB
				LBSR	SUB_CMD
				PULS	A,X
				RTS

*--[ RS-232ChCo ]--------------------------------------------------------

	if	defined(RSDRIVER)
	include	rsdriver.asm
	endif

*--[ DOS ]--------------------------------------------------------------------

	include	diskdrv.asm

*--[ DATA ]-------------------------------------------------------------------

*
*	TuCPU R}h (FM-7)
*
SUBINIT_CMD		FCB		$01,$00,40,25,0,25,0,1,0
SUBCONS_CMD		FCB		$0C,$06
INKEY_CMD		FCB		$29,$03
INKEY_CHK_CMD	FCB		$29,$00

*
*	t@Cl[
*

FBASIC_FN		FCC		/FBASIC10ROM/,0
BOOTBAS_FN		FCC		/BOOTBAS8ROM/,0
BOOTDOS_FN		FCC		/BOOTDOS8ROM/,0
BOOTBBL_FN		FCC		/BOOTBBL8ROM/,0
BOOTDBG_FN		FCC		/BOOTDBG8ROM/,0
BOOTSFD_FN		FCC		/BOOTSFD8ROM/,0
SUBSYSC_FN		FCC		/SUBSYS_8ROM/,0
KANJI_FN		FCC		/KANJI   ROM/,0
*
*	\bZ[W(N)
*

	if	(DISKTYPE==D_NORM2D)
TITLE_MSG		FCB		$12,$06,$06,$11,$07
				FCC		/XM7 ROM SAVE UTILITY for FM-8/
				FCB		$12,$02,$08
				FCC		"(C) 1999 PI. / 2003-2019 Ryu Takegami",0
TITLE_MSG2		FCB		$12,$06,$10,$11,$04
				FCC		/Set blank disk to drive 0 and/,0
	endif
FORMAT_MSG		FCB		$12,$0A,$09,$11,$07
				FCC		/Disk formatting .../,0

*
* \bZ[W(ROMZ[u)
*
FBASIC_MSG		FCB		$12,$09,$09,$11,$07
				FCC		/Saving F-BASIC ROM .../,0
BOOTBAS_MSG		FCB		$12,$05,$09,$11,$07
				FCC		/Saving BOOT ROM(BASIC mode) .../,0
BOOTDOS_MSG		FCB		$12,$06,$09,$11,$07
				FCC		/Saving BOOT ROM(DOS mode) .../,0
BOOTBBL_MSG		FCB		$12,$06,$09,$11,$07
				FCC		/Saving BOOT ROM(BBL mode) .../,0
BOOTDBG_MSG		FCB		$12,$07,$09,$11,$07
				FCC		/Saving BOOT ROM(DBG mode) .../,0
BOOTSFD_MSG		FCB		$12,$07,$09,$11,$07
				FCC		/Saving BOOT ROM(SFD mode) .../,0
KANJI_MSG		FCB		$12,$07,$09,$11,$07
				FCC		/Saving Kanji ROM (JIS78) .../,0
BOOTB_DIPSW_MSG	FCB		$12,$02,$09,$11,$07
				FCC		/Please turn ON DIP SW 9 and DIP SW 10./,0
BOOTD_DIPSW_MSG	FCB		$12,$07,$09,$11,$07
				FCC		/Please turn OFF DIP SW 9 and/
				FCB		$12,$0b,$0b
				FCC		/turn ON DIP SW 10./,0
BOOTL_DIPSW_MSG	FCB		$12,$07,$09,$11,$07
				FCC		/Please turn ON DIP SW 9 and/
				FCB		$12,$0b,$0b
				FCC		/turn OFF DIP SW 10./,0
BOOTG_DIPSW_MSG	FCB		$12,$01,$09,$11,$07
				FCC		/Please turn OFF DIP SW 9 and DIP SW 10./,0
SUBSYSC_MSG		FCB		$12,$02,$09,$11,$07
				FCC		/Saving Sub monitor ROM (200Line) .../,0

*
* \bZ[W(G[)
*
NOTREADY_MSG	FCB		$12,$0C,$10,$11,$02
				FCC		/Drive not ready./,0
WRPROTECT_MSG	FCB		$12,$0A,$10,$11,$02
				FCC		/Disk write protected./,0
SEEKERR_MSG		FCB		$12,$0F,$10,$11,$02
				FCC		/Seek error./,0
READERR_MSG		FCB		$12,$0F,$10,$11,$02
				FCC		/Read error./,0
WRITEERR_MSG	FCB		$12,$0F,$10,$11,$02
				FCC		/Write error./,0
SPACE_MSG		FCB		$12,$0D,$12,$11,$04
				FCC		/Push SPACE key./,0
CLEAR_MSG		FCB		$12,$0A,$10,$11,$07
				FCC		/                     /
				FCB		$12,$0d,$12
				FCC		/               /,0
COMPLETE_MSG	FCB		$12,$0F,$09,$11,$07
				FCC		/Completed./,0

*
* vOI
*
PRGEND			EQU		*
				END
