/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *	Copyright (C) 2010-2018 Toma
 *
 *	[ Win32API RtBM[V ]
 */

#ifdef _WIN32

#ifndef _w32_cfg_h_
#define _w32_cfg_h_

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
void FASTCALL LoadCfg(void);
										/* ݒ胍[h */
BOOL FASTCALL LoadCfg_DoubleSize(void);
										/* ݒ胍[h(2{gp) */
#if XM7_VER >= 3
BOOL FASTCALL LoadCfg_Gravestone(void);
										/* ݒ胍[h(!?) */
BYTE FASTCALL LoadCfg_SubVersion(void);
										/* ݒ胍[h(!?) */
#endif
void FASTCALL SaveCfg(void);
										/* ݒZ[u */
void FASTCALL ApplyCfg(void);
										/* ݒKp */
void FASTCALL GetCfg(void);
										/* ݒ擾 */
void FASTCALL SetMachineVersion(void);
										/* @Đݒ */
void FASTCALL OnConfig(HWND hWnd);
										/* ݒ_CAO */
int FASTCALL ChkMachineVersion(HWND hWnd, BYTE model);
										/* @mF */
void FASTCALL RestoreBootMode(void);
										/* u[g[h𕜌 */
void FASTCALL RestoreFrameWnd(void);
										/* EBhEԂ𕜌 */
BOOL FASTCALL RestoreFullScreen(void);
										/* tXN[Ԃ𕜌 */
void FASTCALL RestoreMediaState(void);
										/* fBAEXe[g𕜌 */
void FASTCALL SetMRUFile(int type, char *string);
										/* MRUZbg */
void FASTCALL SetMRUMedia(int type, int media);
										/* MediaZbg */
void FASTCALL GetMRUFile(int type, int index, char *string, size_t nlen);
										/* MRU擾 */
int FASTCALL GetMRUMedia(int type, int index);
										/* Media擾 */
void FASTCALL DelMRUFile(int type, int index);
										/* MRU폜 */
int FASTCALL GetMRUNum(int type);
										/* MRU擾 */
void FASTCALL SetAllMRUFile(void);
										/* SMRUZbg */

/*
 *	v[N
 */
#ifdef __cplusplus
}
#endif

#endif	/* _w32_cfg_h_ */
#endif	/* _WIN32 */
